diff --git a/Rakefile b/Rakefile
index 9f5959cd..7e4c56d8 100644
--- a/Rakefile
+++ b/Rakefile
@@ -1,14 +1,43 @@
 require "rake/testtask"
 
-# Default suite — everything under test/{unit,integration}. Self-contained,
+# Default suite — everything under test/{unit,integration,packaging}. Self-contained,
 # uses fake-claude / fake-gh, no network or paid API calls.
 Rake::TestTask.new do |t|
   t.libs << "test"
   t.libs << "lib"
-  t.test_files = FileList["test/{unit,integration}/**/*_test.rb"]
+  t.test_files = FileList[
+    "test/{unit,integration}/**/*_test.rb",
+    "test/packaging/**/test_*.rb",
+    "test/packaging/**/*_test.rb"
+  ]
   t.warning = false
 end
 
+namespace :release do
+  desc "Verify TAG (e.g. v0.1.0) matches Hive::VERSION"
+  task :check_version do
+    require_relative "lib/hive/version"
+    tag = ENV.fetch("TAG") { abort "usage: rake release:check_version TAG=vX.Y.Z" }
+    bare = tag.sub(/\Av/, "")
+    abort "tag #{tag} != Hive::VERSION #{Hive::VERSION}" unless bare == Hive::VERSION
+    puts "OK: #{tag} == #{Hive::VERSION}"
+  end
+
+  desc "Write SHA256SUMS for files in DIR (default: dist)"
+  task :checksums do
+    dir = ENV.fetch("DIR", "dist")
+    require "digest"
+    files = Dir[File.join(dir, "*")].select { |f| File.file?(f) }.sort
+    abort "no files in #{dir}" if files.empty?
+    out = files.map do |f|
+      "#{Digest::SHA256.file(f).hexdigest}  #{File.basename(f)}"
+    end
+    path = File.join(dir, "SHA256SUMS")
+    File.write(path, out.join("\n") + "\n")
+    puts "wrote #{path}"
+  end
+end
+
 # Smoke suite — opt-in, runs against real `claude` and a tmp git repo. Costs
 # ~$0.25 per invocation (single brainstorm round). Excluded from the default
 # suite so CI without a claude binary doesn't try to run it.
diff --git a/lib/hive.rb b/lib/hive.rb
index 8db3300a..725a2ed6 100644
--- a/lib/hive.rb
+++ b/lib/hive.rb
@@ -1,5 +1,7 @@
+require_relative "hive/version"
+require_relative "hive/paths"
+
 module Hive
-  VERSION = "0.1.0".freeze
   MIN_CLAUDE_VERSION = "2.1.118".freeze
 
   module Schemas
@@ -40,6 +42,10 @@ module Hive
     # older revision (e.g. for back-compat tests against pinned
     # consumers).
     def self.schema_dir
+      # Prefer installed/source-checkout root (U2); fall back to repo-relative.
+      installed = Hive::Paths.schemas_dir
+      return installed if File.directory?(installed)
+
       File.expand_path("../schemas", __dir__)
     end
 
diff --git a/lib/hive/cli.rb b/lib/hive/cli.rb
index 9bc60cb8..a8390e12 100644
--- a/lib/hive/cli.rb
+++ b/lib/hive/cli.rb
@@ -160,16 +160,58 @@ module Hive
         hive doctor                       # tabular output
         hive doctor --json                # machine-readable envelope
     DESC
+    option :strict, type: :boolean, default: false,
+                    desc: "exit non-zero when optional runtime tools (claude/gh/jq) are missing"
     def doctor
       require "hive/commands/doctor"
       cfg = Hive::Config.load(Dir.pwd)
       exit Hive::Commands::Doctor.new(
         config: cfg,
         project_root: Dir.pwd,
-        json: options[:json]
+        json: options[:json],
+        strict: options[:strict]
       ).call
     end
 
+    desc "update", "Upgrade hive via the channel that installed it (brew / aur / install.sh)"
+    long_desc <<~DESC
+      Detects the install channel (marker file, Homebrew cellar path, pacman
+      ownership, or source checkout) and shells out to that channel's native
+      updater. Never downloads and swaps the binary in place.
+
+        brew  → brew upgrade ivankuznetsov/hive/hive
+        aur   → yay -Syu hive-bin (or paru / helper instructions)
+        bash  → re-run the release install.sh
+        source → git pull && bundle install
+
+      Exit codes: 0 success / printed instructions; 1 unknown channel.
+    DESC
+    option :dry_run, type: :boolean, default: false, desc: "print the upgrade command without running it"
+    def update
+      require "hive/commands/update"
+      exit Hive::Commands::Update.new(dry_run: options[:dry_run]).call
+    end
+
+    desc "uninstall", "Remove hive registrations; preserves project work by default"
+    long_desc <<~DESC
+      Stops and unregisters the daemon service (launchd / systemd --user),
+      then removes channel-owned binary registrations:
+
+        bash  → deletes ~/.local/bin/{hive,hv} and installed share assets
+        brew/aur → prints the native remove command (does not delete package files)
+
+      Prompts (default No) before removing ~/.config/hive/config.yml.
+      Never deletes per-project .hive-state/, worktrees, or completed work.
+      --purge skips prompts and removes config, but still preserves state
+      and work artifacts. Skills are not touched (remove via marketplace).
+    DESC
+    option :purge, type: :boolean, default: false,
+                   desc: "non-interactive: remove config without prompting (still preserves state/work)"
+    def uninstall
+      require "hive/commands/uninstall"
+      exit Hive::Commands::Uninstall.new(purge: options[:purge]).call
+    end
+
     desc "migrate [PROJECT_PATH]", "Rename in-flight task folders from the pre-open-pr stage layout"
     def migrate(project_path = Dir.pwd)
       require "hive/commands/migrate"
diff --git a/lib/hive/commands/doctor.rb b/lib/hive/commands/doctor.rb
index 1b87c603..3d4da83c 100644
--- a/lib/hive/commands/doctor.rb
+++ b/lib/hive/commands/doctor.rb
@@ -35,32 +35,51 @@ module Hive
       EXIT_SUCCESS = 0
       EXIT_MISSING_SKILL = 65
       EXIT_CONFIG_ERROR = 78
+      EXIT_STRICT_DEPS = 65
 
       STAGES = %w[brainstorm plan].freeze
 
+      # Runtime tools checked by U6 / R9. Missing tools are warnings by
+      # default; `--strict` exits non-zero when any required tool is absent.
+      RUNTIME_DEPS = [
+        { name: "git",    required: true,  hint: { brew: "brew install git", pacman: "pacman -S git", apt: "sudo apt install git", default: "install git" } },
+        { name: "bash",   required: true,  hint: { brew: "brew install bash", pacman: "pacman -S bash", apt: "sudo apt install bash", default: "install bash" } },
+        { name: "claude", required: false, hint: { default: "install Claude Code: https://docs.anthropic.com/en/docs/claude-code" } },
+        { name: "gh",     required: false, hint: { brew: "brew install gh", pacman: "pacman -S github-cli", apt: "sudo apt install gh", default: "install GitHub CLI: https://cli.github.com" } },
+        { name: "jq",     required: false, hint: { brew: "brew install jq", pacman: "pacman -S jq", apt: "sudo apt install jq", default: "install jq" } }
+      ].freeze
+
       # Exposes the row set after `#call` has run. Lets in-process
       # callers (e.g., `Hive::Commands::Init`'s preflight) read the
       # probe results directly without re-running the renderer or the
       # JSON encoder. Returns `nil` before `#call` has populated it.
       attr_reader :rows
 
-      def initialize(config:, project_root:, json: false, output: $stdout)
+      def initialize(config:, project_root:, json: false, output: $stdout, strict: false)
         @config = config
         @project_root = project_root
         @json = json
         @output = output
+        @strict = strict
         @rows = nil
       end
 
       def call
-        @rows = check_tmux + check_stages + check_reviewers
+        @rows = check_runtime_deps + check_tmux + check_stages + check_reviewers
         if @json
           @output.puts JSON.generate(envelope(@rows))
         else
           render_table(@rows)
         end
 
-        @rows.any? { |r| failing_status?(r[:status]) } ? EXIT_MISSING_SKILL : EXIT_SUCCESS
+        skill_fail = @rows.any? { |r| r[:kind] != "runtime_dep" && failing_status?(r[:status]) }
+        required_dep_fail = @rows.any? { |r| r[:kind] == "runtime_dep" && r[:status] == "missing" && r[:configured_skill] == "required" }
+        optional_dep_missing = @rows.any? { |r| r[:kind] == "runtime_dep" && r[:status] == "warning" }
+
+        return EXIT_MISSING_SKILL if skill_fail || required_dep_fail
+        return EXIT_STRICT_DEPS if @strict && optional_dep_missing
+
+        EXIT_SUCCESS
       rescue Hive::ConfigError, KeyError, ArgumentError => e
         if @json
           @output.puts JSON.generate(error: e.message)
@@ -76,6 +95,57 @@ module Hive
         status == "missing" || status == "version_too_old"
       end
 
+      def check_runtime_deps
+        RUNTIME_DEPS.map do |dep|
+          present = path_executable?(dep[:name])
+          # Required missing → "missing" (hard fail). Optional missing →
+          # "warning" (informational; --strict makes it fail).
+          status = if present
+                     "present"
+                   elsif dep[:required]
+                     "missing"
+                   else
+                     "warning"
+                   end
+          {
+            kind: "runtime_dep",
+            stage: "runtime",
+            label: "runtime/#{dep[:name]}",
+            agent: dep[:name],
+            configured_skill: dep[:required] ? "required" : "optional",
+            skill: dep[:name],
+            status: status,
+            message: present ? "found on PATH" : "not found — #{hint_for(dep)}"
+          }
+        end
+      end
+
+      def hint_for(dep)
+        hints = dep[:hint] || {}
+        if path_executable?("brew") && hints[:brew]
+          hints[:brew]
+        elsif path_executable?("pacman") && hints[:pacman]
+          hints[:pacman]
+        elsif path_executable?("apt-get") && hints[:apt]
+          hints[:apt]
+        else
+          hints[:default] || "install #{dep[:name]}"
+        end
+      end
+
+      # `command -v` is a shell builtin — cannot be invoked via Kernel.system
+      # as an argv vector. Walk PATH for an executable instead.
+      def path_executable?(name)
+        return false if name.nil? || name.empty?
+        return File.executable?(name) if name.include?(File::SEPARATOR)
+
+        ENV.fetch("PATH", "").split(File::PATH_SEPARATOR).any? do |dir|
+          next if dir.empty?
+
+          File.executable?(File.join(dir, name))
+        end
+      end
+
       def check_stages
         STAGES.map { |stage| check_stage(stage) }
       end
diff --git a/lib/hive/commands/init.rb b/lib/hive/commands/init.rb
index b86e8d61..8c9420d3 100644
--- a/lib/hive/commands/init.rb
+++ b/lib/hive/commands/init.rb
@@ -9,7 +9,8 @@ require "hive/commands/doctor"
 module Hive
   module Commands
     class Init
-      def initialize(project_path, force: false, prompts: nil)
+      def initialize(project_path, force: false, prompts: nil, service: nil,
+                     daemon_prompt_input: nil, daemon_prompt_output: nil)
         @project_path = File.expand_path(project_path)
         @force = force
         # Optional Prompts instance for testability. Tests inject a
@@ -19,6 +20,9 @@ module Hive
         # summary_io: $stdout)` runs (UI on stderr, machine-parseable
         # summary on stdout — see #collect_prompt_answers below).
         @prompts = prompts
+        @service = service
+        @daemon_prompt_input = daemon_prompt_input
+        @daemon_prompt_output = daemon_prompt_output
       end
 
       def call
@@ -43,11 +47,71 @@ module Hive
         ops.add_hive_state_to_master_gitignore!
 
         entry = Hive::Config.register_project(name: File.basename(@project_path), path: @project_path)
+        ensure_first_run_global_config!
+        maybe_register_daemon_service!
 
         print_summary(entry: entry, ops: ops)
         run_init_preflight!
       end
 
+      # First-run global config is created by register_project. Ensure mode
+      # 0600 and emit a one-line note when we just created it (U2 / R12).
+      def ensure_first_run_global_config!
+        path = Hive::Config.global_config_path
+        return unless File.exist?(path)
+
+        File.chmod(0o600, path)
+      rescue Errno::EPERM, Errno::EACCES
+        nil
+      end
+
+      # Register launchd / systemd --user unit. Prompt whether to enable+start
+      # (option c / R11). Never silent-autostart. Non-TTY → register-disabled.
+      # Skip if already registered or service manager unavailable.
+      def maybe_register_daemon_service!
+        require "hive/service"
+        svc = @service || Hive::Service.new
+        if svc.registered?
+          write_warn("hive: daemon service already registered (#{svc.unit_path})")
+          return
+        end
+        unless svc.available?
+          # Quiet skip when the service manager is absent (common in CI /
+          # containers). Only print when an operator might act on it: we
+          # still register when available. Tests assert init is silent on
+          # success paths.
+          return
+        end
+
+        svc.register!
+        enable_now = prompt_enable_daemon?
+        if enable_now
+          svc.start!
+          write_warn("hive: daemon service enabled and started (#{svc.unit_path})")
+        else
+          write_warn("hive: daemon service registered but not started")
+          write_warn("hive: start later with: hive daemon start")
+        end
+      rescue Hive::Service::ServiceError => e
+        write_warn("hive: daemon service registration failed: #{e.message}")
+      end
+
+      def prompt_enable_daemon?
+        # Injectable for tests; production uses $stdin.
+        io_in = @daemon_prompt_input || $stdin
+        io_out = @daemon_prompt_output || $stderr
+        unless io_in.respond_to?(:tty?) && io_in.tty?
+          io_out.puts "hive: non-interactive init — daemon registered but not started (run `hive daemon start`)"
+          return false
+        end
+        io_out.print "Enable and start the hive daemon service now? [y/N] "
+        io_out.flush if io_out.respond_to?(:flush)
+        line = io_in.gets
+        return false if line.nil?
+
+        line.strip.match?(/\A(y|yes)\z/i)
+      end
+
       # Non-fatal skill preflight: after init succeeds, run the doctor
       # against the freshly-written config and emit stderr warnings for
       # any `:missing` rows. Init's exit code is unaffected — install
@@ -73,7 +137,11 @@ module Hive
           return
         end
 
-        missing = Array(doctor.rows).select { |r| r[:status] == "missing" }
+        # Only skill / required-dep hard failures — not optional runtime
+        # warnings (claude/gh/jq) and not "warning" rows.
+        missing = Array(doctor.rows).select do |r|
+          r[:status] == "missing" || r[:status] == "version_too_old"
+        end
         return if missing.empty?
 
         emit_preflight_warnings(missing)
@@ -172,7 +240,8 @@ module Hive
 
       def render_project_config(ops, answers:)
         require "erb"
-        template = File.read(File.expand_path("../../../templates/project_config.yml.erb", __dir__))
+        require "hive/paths"
+        template = File.read(Hive::Paths.template_path("project_config.yml.erb"))
         bindings = ProjectConfigBinding.new(
           project_name: File.basename(@project_path),
           default_branch: ops.default_branch,
diff --git a/lib/hive/commands/new.rb b/lib/hive/commands/new.rb
index bd719216..d1b4d9ba 100644
--- a/lib/hive/commands/new.rb
+++ b/lib/hive/commands/new.rb
@@ -138,7 +138,8 @@ module Hive
       end
 
       def render_idea(slug, text, body_override: nil)
-        template = File.read(File.expand_path("../../../templates/idea.md.erb", __dir__))
+        require "hive/paths"
+        template = File.read(Hive::Paths.template_path("idea.md.erb"))
         bindings = IdeaBinding.new(
           slug: slug,
           original_text: text,
diff --git a/lib/hive/commands/uninstall.rb b/lib/hive/commands/uninstall.rb
new file mode 100644
index 00000000..6e9e9c0e
--- /dev/null
+++ b/lib/hive/commands/uninstall.rb
@@ -0,0 +1,131 @@
+# frozen_string_literal: true
+
+require "fileutils"
+require "hive/install_channel"
+require "hive/paths"
+require "hive/service"
+
+module Hive
+  module Commands
+    # `hive uninstall` — remove binary registrations; preserve work by default (R14).
+    #
+    # Order:
+    #   1. stop + unregister daemon units
+    #   2. channel-aware binary removal (instruct brew/aur; delete bash files)
+    #   3. prompt before touching config/state (default No); --purge skips prompts
+    #      but still preserves state/work artifacts
+    #   4. never touches per-project .hive-state / worktrees unless opted in
+    class Uninstall
+      def initialize(purge: false, input: $stdin, output: $stdout,
+                     channel: nil, service: nil, yes_all: false)
+        @purge = purge
+        @input = input
+        @output = output
+        @channel = channel
+        @service = service
+        @yes_all = yes_all
+      end
+
+      def call
+        channel = (@channel || Hive::InstallChannel.detect).to_sym
+        @output.puts "hive uninstall: channel=#{channel}"
+
+        teardown_service!
+        remove_binary!(channel)
+        maybe_remove_config!
+        # State is preserved even with --purge (R14 / brainstorm constraint).
+        @output.puts "Preserved: #{Hive::Paths.state_dir} (daemon logs / global state)"
+        @output.puts "Preserved: per-project .hive-state/ and worktrees (pipeline work)"
+        @output.puts "Skills are managed via your agent marketplace — not removed by hive uninstall."
+        0
+      end
+
+      private
+
+      def teardown_service!
+        svc = @service || Hive::Service.new
+        if svc.registered?
+          @output.puts "Stopping and unregistering daemon service…"
+          svc.stop!
+          svc.unregister!
+          @output.puts "  daemon service removed"
+        else
+          @output.puts "No daemon service registration found."
+        end
+      rescue Hive::Service::ServiceError => e
+        @output.puts "  warning: service teardown incomplete: #{e.message}"
+      end
+
+      def remove_binary!(channel)
+        case channel
+        when :brew, :aur
+          cmd = Hive::InstallChannel.uninstall_command(channel)
+          @output.puts "This install is owned by #{channel}. Remove it with:"
+          @output.puts "  #{cmd}"
+          @output.puts "(hive uninstall will not delete package-manager-owned files)"
+        when :bash
+          remove_bash_install!
+        else
+          @output.puts "Source/unknown install: remove the checkout or PATH symlink yourself."
+          @output.puts "  binary: #{$PROGRAM_NAME}"
+        end
+      end
+
+      def remove_bash_install!
+        targets = [
+          File.expand_path("~/.local/bin/hive"),
+          File.expand_path("~/.local/bin/hv")
+        ]
+        share = Hive::Paths.data_dir
+        # Only remove share dir contents that look like our install (templates/schemas).
+        share_targets = %w[templates schemas lib bin hive install-channel.yml].map do |n|
+          File.join(share, n)
+        end
+
+        targets.each do |t|
+          if File.exist?(t) || File.symlink?(t)
+            FileUtils.rm_f(t)
+            @output.puts "  removed #{t}"
+          end
+        end
+
+        share_targets.each do |t|
+          if File.directory?(t)
+            FileUtils.rm_rf(t)
+            @output.puts "  removed #{t}/"
+          elsif File.exist?(t)
+            FileUtils.rm_f(t)
+            @output.puts "  removed #{t}"
+          end
+        end
+      end
+
+      def maybe_remove_config!
+        cfg = Hive::Paths.global_config_path
+        return unless File.exist?(cfg)
+
+        if @purge || confirm?("Remove global config #{cfg}? [y/N] ")
+          FileUtils.rm_f(cfg)
+          # Remove empty config dir if we emptied it.
+          dir = Hive::Paths.config_dir
+          FileUtils.rmdir(dir) if File.directory?(dir) && Dir.empty?(dir)
+          @output.puts "  removed #{cfg}"
+        else
+          @output.puts "  kept #{cfg}"
+        end
+      end
+
+      def confirm?(prompt)
+        return true if @yes_all
+        return false if @purge == false && !@input.tty? && !@yes_all
+
+        @output.print(prompt)
+        @output.flush if @output.respond_to?(:flush)
+        line = @input.gets
+        return false if line.nil?
+
+        line.strip.match?(/\A(y|yes)\z/i)
+      end
+    end
+  end
+end
diff --git a/lib/hive/commands/update.rb b/lib/hive/commands/update.rb
new file mode 100644
index 00000000..0c47981e
--- /dev/null
+++ b/lib/hive/commands/update.rb
@@ -0,0 +1,50 @@
+# frozen_string_literal: true
+
+require "hive/install_channel"
+
+module Hive
+  module Commands
+    # `hive update` — delegate to the owning install channel's updater (R13).
+    # Never downloads-and-swaps the binary itself.
+    class Update
+      def initialize(channel: nil, exec: method(:default_exec), output: $stdout, dry_run: false)
+        @channel = channel
+        @exec = exec
+        @output = output
+        @dry_run = dry_run
+      end
+
+      def call
+        channel = (@channel || Hive::InstallChannel.detect).to_sym
+        cmd = Hive::InstallChannel.update_command(channel)
+
+        if cmd.nil?
+          @output.puts "hive update: unknown install channel."
+          @output.puts "If you installed from source: git pull && bundle install"
+          @output.puts "Otherwise reinstall via: https://github.com/ivankuznetsov/hive#install"
+          return 1
+        end
+
+        if cmd.start_with?("#")
+          @output.puts "hive update: detected channel=#{channel}"
+          @output.puts cmd
+          return 0
+        end
+
+        @output.puts "hive update: channel=#{channel}"
+        @output.puts "→ #{cmd}"
+        return 0 if @dry_run
+
+        # Shell out so channel helpers (brew/yay/curl|bash) work as operators expect.
+        @exec.call(cmd)
+      end
+
+      private
+
+      def default_exec(cmd)
+        # Use a login-capable shell so brew/yay are on PATH for typical installs.
+        Kernel.exec("/bin/bash", "-lc", cmd)
+      end
+    end
+  end
+end
diff --git a/lib/hive/config.rb b/lib/hive/config.rb
index a67097d8..29118084 100644
--- a/lib/hive/config.rb
+++ b/lib/hive/config.rb
@@ -1,6 +1,7 @@
 require "yaml"
 require "fileutils"
 require "hive/agent_profiles"
+require "hive/paths"
 
 module Hive
   module Config
@@ -158,8 +159,9 @@ module Hive
       },
       # Global Telegram bot settings. The bot is an operator surface
       # across every registered project, so runtime code loads these
-      # from ~/Dev/hive/config.yml via load_global_bot. The token lives
-      # only in HIVE_TELEGRAM_BOT_TOKEN and is never persisted.
+      # from the global config (XDG config dir / HIVE_HOME) via
+      # load_global_bot. The token lives only in HIVE_TELEGRAM_BOT_TOKEN
+      # and is never persisted. pid/log paths are resolved at load time.
       "bot" => {
         "enabled" => false,
         "chat_id_allowlist" => [],
@@ -170,11 +172,11 @@ module Hive
         "codex_budget_usd" => 1,
         "codex_timeout_sec" => 120,
         "shutdown_grace_sec" => 60,
-        "pid_file" => "~/Dev/hive/.bot.pid",
-        "log_file" => "~/Dev/hive/logs/bot.log",
+        "pid_file" => nil,
+        "log_file" => nil,
         "log_max_bytes" => 10_485_760,
         "log_max_files" => 5,
-        "last_seen_state_file" => "~/Dev/hive/.bot.last_seen_update_id"
+        "last_seen_state_file" => nil
       },
       # Auto-rebase pre-step for `hive run` (plan
       # docs/plans/2026-05-14-001-feat-hive-auto-rebase-stale-worktree-plan.md).
@@ -208,12 +210,15 @@ module Hive
 
     module_function
 
+    # Global home for daemon/bot pid+logs. Honors HIVE_HOME; otherwise
+    # resolves to the XDG state dir (~/.local/state/hive). Prefer
+    # Hive::Paths helpers for new code.
     def hive_home
-      ENV["HIVE_HOME"] || File.expand_path("~/Dev/hive")
+      Hive::Paths.hive_home
     end
 
     def global_config_path
-      File.join(hive_home, "config.yml")
+      Hive::Paths.global_config_path
     end
 
     def hive_state_dir(project_root, hive_state_name = ".hive-state")
@@ -317,7 +322,9 @@ module Hive
     # call site. Permission errors on write surface as ConfigError
     # (exit 78), matching the read-side classification.
     def write_global_config!(data)
+      Hive::Paths.ensure_config_dir!
       File.write(global_config_path, data.to_yaml)
+      File.chmod(0o600, global_config_path)
     rescue Errno::EACCES, Errno::EROFS, Errno::ENOSPC => e
       raise ConfigError, "global config at #{global_config_path} could not be written: #{e.message}"
     end
@@ -386,14 +393,16 @@ module Hive
 
     def global_bot_defaults
       defaults = deep_dup(DEFAULTS["bot"])
-      defaults["pid_file"] = File.join(hive_home, ".bot.pid")
-      defaults["log_file"] = File.join(hive_home, "logs", "bot.log")
-      defaults["last_seen_state_file"] = File.join(hive_home, ".bot.last_seen_update_id")
+      home = hive_home
+      defaults["pid_file"] = File.join(home, ".bot.pid")
+      defaults["log_file"] = File.join(home, "logs", "bot.log")
+      defaults["last_seen_state_file"] = File.join(home, ".bot.last_seen_update_id")
       defaults
     end
 
     def register_project(name:, path:)
-      FileUtils.mkdir_p(hive_home)
+      Hive::Paths.ensure_config_dir!
+      Hive::Paths.ensure_state_dir!
       data = if File.exist?(global_config_path)
                load_global_config(global_config_path)
       else
diff --git a/lib/hive/install_channel.rb b/lib/hive/install_channel.rb
new file mode 100644
index 00000000..747b4bdd
--- /dev/null
+++ b/lib/hive/install_channel.rb
@@ -0,0 +1,163 @@
+# frozen_string_literal: true
+
+require "open3"
+require "shellwords"
+require "yaml"
+require "hive/paths"
+
+module Hive
+  # Channel-of-record detection for packaged installs (KTD5 / U7).
+  #
+  # Priority:
+  #   1. Marker file at ~/.local/share/hive/install-channel.yml (or data_dir)
+  #   2. Heuristics: Homebrew cellar path → brew; pacman owns file → aur
+  #   3. :unknown (source checkout / manual)
+  module InstallChannel
+    KNOWN = %i[brew aur bash unknown source].freeze
+
+    module_function
+
+    def detect(binary_path: nil, runner: nil)
+      marker = read_marker
+      return marker[:channel].to_sym if marker && marker[:channel]
+
+      path = binary_path || resolve_binary
+      return :source if source_checkout_binary?(path)
+
+      return :brew if brew_path?(path)
+      return :aur if pacman_owns?(path, runner: runner)
+      return :bash if bash_install_path?(path)
+
+      :unknown
+    end
+
+    def read_marker
+      path = Hive::Paths.channel_marker_path
+      return nil unless File.file?(path)
+
+      data = YAML.safe_load(File.read(path)) || {}
+      return nil unless data.is_a?(Hash)
+
+      channel = data["channel"] || data[:channel]
+      return nil if channel.nil? || channel.to_s.empty?
+
+      {
+        channel: channel.to_s,
+        version: data["version"] || data[:version],
+        install_path: data["install_path"] || data[:install_path],
+        installed_at: data["installed_at"] || data[:installed_at]
+      }
+    rescue Psych::Exception
+      nil
+    end
+
+    def write_marker!(channel:, version: Hive::VERSION, install_path: nil)
+      Hive::Paths.ensure_data_dir!
+      payload = {
+        "channel" => channel.to_s,
+        "version" => version.to_s,
+        "install_path" => install_path,
+        "installed_at" => Time.now.utc.iso8601
+      }
+      File.write(Hive::Paths.channel_marker_path, payload.to_yaml)
+      File.chmod(0o644, Hive::Paths.channel_marker_path)
+      payload
+    end
+
+    def update_command(channel = detect)
+      case channel.to_sym
+      when :brew
+        "brew upgrade ivankuznetsov/hive/hive"
+      when :aur
+        if command_exists?("yay")
+          "yay -Syu hive-bin"
+        elsif command_exists?("paru")
+          "paru -Syu hive-bin"
+        else
+          "# use your AUR helper to upgrade hive-bin, e.g.: yay -Syu hive-bin"
+        end
+      when :bash
+        "curl -fsSL https://github.com/ivankuznetsov/hive/releases/latest/download/install.sh | bash"
+      when :source
+        "cd #{Hive::Paths.repo_root.shellescape} && git pull && bundle install"
+      else
+        nil
+      end
+    end
+
+    def uninstall_command(channel = detect)
+      case channel.to_sym
+      when :brew
+        "brew uninstall hive"
+      when :aur
+        if command_exists?("yay")
+          "yay -R hive-bin"
+        elsif command_exists?("paru")
+          "paru -R hive-bin"
+        else
+          "sudo pacman -R hive-bin"
+        end
+      else
+        nil
+      end
+    end
+
+    def brew_path?(path)
+      return false if path.nil? || path.empty?
+
+      expanded = File.expand_path(path)
+      expanded.include?("/Cellar/hive/") ||
+        expanded.include?("/homebrew/") ||
+        expanded.match?(%r{/opt/homebrew/}) ||
+        expanded.match?(%r{/linuxbrew/}) ||
+        expanded.match?(%r{/Homebrew/})
+    end
+
+    def bash_install_path?(path)
+      return false if path.nil? || path.empty?
+
+      expanded = File.expand_path(path)
+      local_bin = File.expand_path("~/.local/bin/hive")
+      expanded == local_bin || expanded.end_with?("/.local/bin/hive")
+    end
+
+    def pacman_owns?(path, runner: nil)
+      return false if path.nil? || path.empty?
+      return false unless command_exists?("pacman")
+
+      runner ||= ->(args) { Open3.capture3(*args) }
+      _out, _err, status = runner.call(%W[pacman -Qo #{path}])
+      status.success?
+    rescue StandardError
+      false
+    end
+
+    def source_checkout_binary?(path)
+      # Only treat as source when the binary path itself is the repo's
+      # bin/hive. Do not use global source_checkout? — that is always true
+      # while developing and would shadow brew/bash/aur heuristics in tests.
+      return false if path.nil? || path.empty?
+
+      expanded = File.expand_path(path)
+      repo_bin = File.expand_path(File.join(Hive::Paths.repo_root, "bin", "hive"))
+      expanded == repo_bin
+    end
+
+    def resolve_binary
+      return $PROGRAM_NAME if File.exist?($PROGRAM_NAME)
+
+      which = `command -v hive 2>/dev/null`.strip
+      which.empty? ? nil : which
+    end
+
+    def command_exists?(name)
+      return false if name.nil? || name.empty?
+
+      ENV.fetch("PATH", "").split(File::PATH_SEPARATOR).any? do |dir|
+        next if dir.empty?
+
+        File.executable?(File.join(dir, name))
+      end
+    end
+  end
+end
